package com.loafle.overflow.crawler;

import org.snmp4j.Snmp;
import org.snmp4j.TransportMapping;
import org.snmp4j.smi.Address;
import org.snmp4j.transport.DefaultUdpTransportMapping;

import java.io.IOException;
import java.util.Map;

/**
 * Created by insanity on 17. 4. 10.
 */
public class SNMPCrawler extends Crawler {

    //v2c
    private static String addr = "192.168.1.215";
    private static String port = "161";
    private static String community = "public";

    /**
     * v3
     * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
     * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
     * loafle3 MD5 "qwer5795" : AUTHNOPRIV
     * loafle4 :NOAUTHNOPRIV
     */
    private static String user = "loafle3";
    private static int authType = 1;
    private static String authPass = "qwer5795";
    private static int privType = 0;
    private static String privPass = "qweqwe123";

    public enum MethodType {
        VALIDATE, GET, WALK;
    }

    @Override
    public Object get(String id) {
        //return getByV2c(MethodType.VALIDATE, null);
        //return getByV2c(MethodType.GET, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
        return getByV2c(MethodType.WALK, new String[]{"1.3.6.1.2.1.25.2.3.1.3"});


        //return getByV3(MethodType.VALIDATE, null);
        //return getByV3(MethodType.GET, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
        //return getByV3(MethodType.WALK, new String[]{"1.3.6.1.2.1.25.2.3.1.3"});
    }

    private Object getByV2c(MethodType type, String[] oids) {
        Snmp snmp = null;
        TransportMapping<? extends Address> transport = null;
        try {
            transport = new DefaultUdpTransportMapping();
            snmp = new Snmp(transport);
            transport.listen();
            SNMPv2c snmpV2 = new SNMPv2c(snmp);

            switch (type) {
                case VALIDATE:
                    return snmpV2.validate(addr, port, community);
                case GET:
                    return snmpV2.get(addr, port, community, oids);
                case WALK:
                    return snmpV2.walk(addr, port, community, oids[0]);
                default:
                    return null;
            }

        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        } finally {
            if (snmp != null) {
                try {
                    snmp.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (transport != null) {
                try {
                    transport.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }

    private Object getByV3(MethodType type, String[] oids) {
        Snmp snmp = null;
        TransportMapping<? extends Address> transport = null;

        try {
            transport = new DefaultUdpTransportMapping();
            snmp = new Snmp(transport);
            transport.listen();
            SNMPv3 snmpV3 = new SNMPv3(snmp);

            switch (type) {
                case VALIDATE:
                    return snmpV3.validate(addr, port, user, authType, authPass, privType, privPass);
                case GET:
                    return snmpV3.get(addr, port, user, authType, authPass, privType, privPass, oids);
                case WALK:
                    return snmpV3.walk(addr, port, user, authType, authPass, privType, privPass, oids[0]);
                default:
                    return null;
            }

        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        } finally {
            if (snmp != null) {
                try {
                    snmp.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (transport != null) {
                try {
                    transport.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }

}